/*
<:copyright-broadcom 
 
 Copyright (c) 2005 Broadcom Corporation 
 All Rights Reserved 
 No portions of this material may be reproduced in any form without the 
 written permission of: 
          Broadcom Corporation 
          16215 Alton Parkway 
          Irvine, California 92619 
 All information contained in this document is Broadcom Corporation 
 company private, proprietary, and trade secret. 
 
:>
*/
/*
  ATM bonding slave module, header file
  Based on the ATM API

  By Maxime Collignon
  Created on January 15th, 2005
*/

#ifndef SLAVE_H

#define SLAVE_H

#include "BOSW.h"

struct BONDS_Statistics_s
{
  UINT32 rx_cells;
  UINT32 tx_cells;
  UINT32 tx_pushed_cells;
  UINT32 tx_max_delay;
  UINT32 tx_max_delay2;
  UINT32 rx_nomem_dropped;
  UINT32 tx_nomem_dropped;
  UINT32 tx_tmstp_dropped;
  UINT32 tx_send_error_dropped;
  UINT32 tx_ATMAPI_freed;
  UINT32 tx_freed;
  UINT32 polled;
  UINT32 interrupts;
  UINT32 rx_memcpy_small_pkts;
};

extern struct BONDS_Statistics_s * const BONDS_Statisticsp;

#define US_RATE_LIMIT_BYTES        ((6000000)/8)
#define U32_DIFF(a,b)        (((a)-(b)) & 0x7fffffff)
struct AAL5forward_Statistics_s
{
  uint32 rx_frames;
  uint32 rx_bytes;
  uint32 tx_frames;
  uint32 tx_bytes;
  uint32 rx_incomplete_frames;
  uint32 rx_wrong_frames;
  uint32 rx_nomem_dropped;
  uint32 rx_wrong_crc;
  uint32 tx_nomem_dropped;
  uint32 tx_copies;
  uint32 blaa_sends ;
  uint32 tx_prev_bytes ;
};

extern struct AAL5forward_Statistics_s * const AAL5forward_Statisticsp;

struct MultiAAL5forward_Statistics_s
{
  uint32 rx_frames;
  uint32 rx_bytes;
  uint32 tx_frames;
  uint32 tx_bytes;
  uint32 rx_incomplete_frames;
  uint32 rx_wrong_frames;
  uint32 rx_nomem_dropped;
  uint32 rx_nobuf_dropped;
  uint32 rx_noinfostruct_dropped;
  uint32 tx_nomem_dropped;
};

extern struct MultiAAL5forward_Statistics_s * const MultiAAL5forward_Statisticsp;

void atmbonding_slave_getStateReq(BOSW_BufferDesc *bufp, void *data);
uint8 *atmbonding_slave_get_master_MacAddress(void);
int atmbonding_slave_isMasterKnown(void);
void atmbonding_slave_send_AAL5(uint32 vpvc, BOSW_BufferDesc *bufp, void *data);

#ifndef TIMER_0
extern void atmbonding_slave_send_cells(void *data) ;
#endif

UINT32 atmOsDisableInts( void );
void atmOsEnableInts( UINT32 flags );

#include "bcmadsl.h"
typedef UINT32 (*FN_ADSL_GET_CONN_INFO) (PADSL_CONNECTION_INFO) ;
#endif
