/*
<:copyright-broadcom 
 
 Copyright (c) 2005 Broadcom Corporation 
 All Rights Reserved 
 No portions of this material may be reproduced in any form without the 
 written permission of: 
          Broadcom Corporation 
          16215 Alton Parkway 
          Irvine, California 92619 
 All information contained in this document is Broadcom Corporation 
 company private, proprietary, and trade secret. 
 
:>
*/
/* ATM bonding main module, header file
   By Maxime Collignon
   Created on February 2nd, 2005
*/
#ifndef ATMBONDING_H

#define ATMBONDING_H
#include "BOSW.h"
#include "AAL5relay.h"
#include "master.h"

extern int atmbonding_enabled;
extern int atmbonding_slave_enabled;
extern int atmbonding_master_enabled;

struct atmbonding_slave_ops
{
  int (*start) (void);
};

struct atmbonding_master_ops
{
  int (*start) (void);
};

int atmbonding_register_slave(struct atmbonding_slave_ops *ops);
int atmbonding_register_master(struct atmbonding_master_ops *ops);

typedef void (*USCellTxCb)(uint8 *framep, void *data);
;
int BondM_registerUSCellTx(USCellTxCb func, void *data);

AtmVccEntry *atmbonding_getVccTable(void);
int atmbonding_updatedConfig(void);
int atmbonding_isBondingBypassed(void);

#define BONDING_BYPASS_FLAG        (1 << 0)
#define OAM_LOOPBACK_FLAG          (1 << 1)
#define OAM_FORWARD_FLAG           (1 << 2)
#define DS_AAL5_CRC32_FLAG         (1 << 3)
#define AAL5_TRAILER_FORWARD_FLAG  (1 << 4)
#define BONDING_FALLBACK_FLAG      (1 << 5)

uint32 atmbonding_getFlags(void);
void atmbonding_setFlags(uint32 flags);

#endif
